<?php

namespace IMATHUZH\Qfq\Core\Renderer\FormElement\Bootstrap3;

use IMATHUZH\Qfq\Core\Form\FormElement\AbstractFormElement;
use IMATHUZH\Qfq\Core\Form\FormElement\FieldsetFormElement;
use IMATHUZH\Qfq\Core\Helper\Support;
use IMATHUZH\Qfq\Core\Renderer\FormElement\Base\FieldsetRenderer;

class Bootstrap3FieldsetRenderer extends FieldsetRenderer
{
    /**
     * Renders the fieldset container and all its nested formelements (children).
     * @param AbstractFormElement $fe
     * @param string $renderMode
     * @return string
     */
    public function renderFormElement(AbstractFormElement $fe, string $renderMode = RENDER_MODE_HTML): string
    {
        // <fieldset>
        $html = '<fieldset class="qfq-fieldset " ' . Support::arrayToXMLAttributes($fe->htmlAttributes) . '>';

        if ($fe->attributes[FE_LABEL] !== '') {
            $html .= '<legend>' . $fe->attributes[FE_LABEL] . '</legend>';
        }

        //$html .= $this->wrap[WRAP_SETUP_IN_FIELDSET][WRAP_SETUP_START];
        //$html .= $this->wrap[WRAP_SETUP_IN_FIELDSET][WRAP_SETUP_END];

        $html .= $this->renderChildren($fe, $renderMode);
        $html .= '</fieldset>';

        //$wrapSetupClass = $this->wrap[WRAP_SETUP_ELEMENT][WRAP_SETUP_CLASS] ?? '';
        //$json = $this->getFormElementForJson($htmlFormElementName, $value, $formElement, $wrapSetupClass);

        return $html;
    }
}